#!/bin/sh -e

#directory
Terpstra_dir=/home/debian/TerpstraController
config_dir=/home/debian/config

#create_dir () {
if [ ! -e $Terpstra_dir ]; then
    echo "Creating dir $Terpstra_dir"
    mkdir $Terpstra_dir
    echo "Copying Lumatone Installer shell script ..."
    cp lmtn_launcher.sh $Terpstra_dir
fi
#}

#NOTE: shell script must be unixified prior to upload to beaglebone as unixify function does not exist on beaglebones
#if unixify is not done, shell script will not execute and fail

echo "Copying executables to proper locations..."
#configure application files to executables
cd /home/debian/config

cp TerpstraController $Terpstra_dir         
cp picberry $Terpstra_dir                   
cp CA004_Test $Terpstra_dir             
cp LMTN-01_OctaveBoard.X.production.hex $Terpstra_dir/LMTN-01_OctaveBoard.hex
chmod +x ${Terpstra_dir}/TerpstraController
chmod +x ${Terpstra_dir}/picberry
chmod +x ${Terpstra_dir}/CA004_Test

echo "Copy default presets"
tar xzf defaults.tgz -C $Terpstra_dir

echo "Copying uEnv boot file..."
#replace uEnv file
sudo cp uEnv.txt /boot/

echo "Copying tree overlay files..."
#create the dtbo file from dts file and move to appropriate location
cpp -nostdinc -I include -I arch  -undef -x assembler-with-cpp LMTN-GPIO-00A0.dts LMTN-GPIO-00A0.dts.preprocessed
dtc -O dtb -o LMTN-GPIO-00A0.dtbo -b 0 -@ LMTN-GPIO-00A0.dts.preprocessed
sudo mv LMTN-GPIO-00A0.dtbo /lib/firmware/

echo "Copying systemd files..."
#launch the autoscript set up
sudo cp lmtn_gpiosetup.service /lib/systemd/system
sudo systemctl enable lmtn_gpiosetup.service

echo "Copying usb config settings..."
#replace usb set up script with custom and replace dependent usb config files
sudo cp am335x_evm.sh /opt/scripts/boot/
sudo cp bb-boot /etc/default/

echo "disable bonescript services..."
#disable bonescript if currently enabled in systemd
sudo systemctl disable bonescript.service bonescript.socket bonescript-autorun.service

if [ -e ${Terpstra_dir}/files ]; then
	echo "files folder generated, check fw version..."
	if [ -e ${Terpstra_dir}/fw_rev.txt ]; then
		curr_fw=`cat ${Terpstra_dir}/fw_rev.txt`
		echo "current fw version: ${curr_fw}"

		package_fw=`cat ${config_dir}/fw_rev.txt`
		echo "package fw version: ${package_fw}"

		#optional changes can be made here
		#application will update files accordingly upon initial startup on next execute

	else
		echo "fw_rev.txt not found, fw_rev < 1.0.8"
		if [ -e ${Terpstra_dir}/files/GlobalSettings ]; then 
			echo "removing GlobalSettings file..."
			sudo rm ${Terpstra_dir}/files/GlobalSettings
		fi

		echo "generating revision 1.0.7 fw_rev.txt..."
		touch ${Terpstra_dir}/fw_rev.txt
		echo "1.0.7" > ${Terpstra_dir}/fw_rev.txt
	fi
else
	echo "files folder not generated by app, first time unpacking"
	cp fw_rev.txt $Terpstra_dir
fi

